#ifndef IRQ_H
#define IRQ_H

#include "main.h"

#define IRQTABLE_VBL		0
#define IRQTABLE_HBL		1
#define IRQTABLE_YTRIG	2
#define IRQTABLE_TM0		3
#define IRQTABLE_TM1		4
#define IRQTABLE_TM2		5
#define IRQTABLE_TM3		6
#define IRQTABLE_COMMS	7
#define IRQTABLE_DMA0	8
#define IRQTABLE_DMA1	9
#define IRQTABLE_DMA2	10
#define IRQTABLE_DMA3	11
#define IRQTABLE_KEY		12
#define IRQTABLE_CART	13

extern u32 irqTable[];

extern void Irq() IN_IWRAM;
extern void IrqNull() IN_IWRAM;

#endif
