#ifndef MISC_H
#define MISC_H

#include "main.h"

extern void VSync();
extern inline void LoadBgPal(const u16*);
extern inline void LoadBgPal16(u8, const u16*);
extern inline void LoadObjPal(const u16*);
extern inline void LoadObjPal16(u8, const u16*);
extern void memset(void*, u8, u32);
extern void memcpy(void*, void*, u32);
extern inline void Dma0(void*, const void*, u32, u16);
extern inline void Dma1(void*, const void*, u32, u16);
extern inline void Dma2(void*, const void*, u32, u16);
extern inline void Dma3(void*, const void*, u32, u16);
extern void SoftReset();
extern s32 UnCompLZ77WRam(void*, void*);
extern s32 UnCompLZ77VRam(void*, void*);
extern void CpuSet(void*, void*, u32);
extern void CpuFastSet(void*, void*, u32);
extern void BgAffineSet(BgAffineSrc*, BgAffineDest*, u32);
extern void ObjAffineSet(ObjAffineSrc*, ObjAffineDest*, u32, u32);
extern void FontLoad(u8, u16);
extern void FontPrint(u8, u8, u16*, char*, u8);
extern void CalcGradient(u8, u16, u8, u16);
extern void MakeTrigTable(s32*, u32);
extern void MakeRcpTable(s32*, u32);

#endif
