.equ mixLoopRtn,	104
.equ sndFp, 8
.equ volSh, 7
.equ sndBase, 0x8000000

.global SndMixLoop
.section .iwram, "ax", %progbits
.arm
.align 4
.type SndMixLoop, function
SndMixLoop:
adr r1, tempStack
str r0, [r1]

snd_loop:
	mov r0, #sndBase
	ldrb r1, [r0, r5, LSR #sndFp]
	add r5, r5, r6
	mla r1, r7, r1, r4

	ldrb r0, [r0, r8, LSR #sndFp]
	add r8, r8, r9
	mla r1, r10, r0, r1

	ldrb r0, [r12], #1
	mla r1, r11, r0, r1

	ldrb r0, [r14], #1
	mla r1, r13, r0, r1

	mov r1, r1, ASR #(8 + volSh)

	strb r1, [r3], #1

	sub r2, r2, #1
	tst r2, #3
	bne snd_loop

	cmp r2, #0
	beq snd_loop_end

snd_fast_loop:
	mov r0, #sndBase
	ldrb r1, [r0, r5, LSR #sndFp]
	add r5, r5, r6
	mla r1, r7, r1, r4

	ldrb r0, [r0, r8, LSR #sndFp]
	add r8, r8, r9
	mla r1, r10, r0, r1

	ldrb r0, [r12], #1
	mla r1, r11, r0, r1

	ldrb r0, [r14], #1
	mla r1, r13, r0, r1

	mov r1, r1, ASR #(8 + volSh)

	strb r1, [r3], #1

	mov r0, #sndBase
	ldrb r1, [r0, r5, LSR #sndFp]
	add r5, r5, r6
	mla r1, r7, r1, r4

	ldrb r0, [r0, r8, LSR #sndFp]
	add r8, r8, r9
	mla r1, r10, r0, r1

	ldrb r0, [r12], #1
	mla r1, r11, r0, r1

	ldrb r0, [r14], #1
	mla r1, r13, r0, r1

	mov r1, r1, ASR #(8 + volSh)

	strb r1, [r3], #1

	mov r0, #sndBase
	ldrb r1, [r0, r5, LSR #sndFp]
	add r5, r5, r6
	mla r1, r7, r1, r4

	ldrb r0, [r0, r8, LSR #sndFp]
	add r8, r8, r9
	mla r1, r10, r0, r1

	ldrb r0, [r12], #1
	mla r1, r11, r0, r1

	ldrb r0, [r14], #1
	mla r1, r13, r0, r1

	mov r1, r1, ASR #(8 + volSh)

	strb r1, [r3], #1

	mov r0, #sndBase
	ldrb r1, [r0, r5, LSR #sndFp]
	add r5, r5, r6
	mla r1, r7, r1, r4

	ldrb r0, [r0, r8, LSR #sndFp]
	add r8, r8, r9
	mla r1, r10, r0, r1

	ldrb r0, [r12], #1
	mla r1, r11, r0, r1

	ldrb r0, [r14], #1
	mla r1, r13, r0, r1

	mov r1, r1, ASR #(8 + volSh)

	strb r1, [r3], #1

	subs r2, r2, #4
	bne snd_fast_loop

	snd_loop_end:

	adr r0, tempStack
	ldr r0, [r0]
	ldr r1, [r0, #mixLoopRtn]
	bx r1

tempStack:
.word 0
