#include "main.h"

u16 fontTileStart = 0;

void FontLoad(u8 charBlock, u16 tileStart)
{
	fontTileStart = tileStart;
	UnCompLZ77VRam(dFontBg, 
		(void*)((0x6000000 + (((u32)charBlock) << 14)) + 
		(((u32)tileStart) << 5)));
}

void FontPrint(u8 x, u8 y, u16 *dest, char *text, u8 wShift)
{
	char *i;

	if(text)
	{
		dest += x + (y << wShift);
		for(i = text + strlen(text); text < i; text++)
			*dest++ = fontTileStart + dFontMapBg[*text - 32];
	}
}
